gfpcrypt.h File Reference

Classes and functions for schemes based on Discrete Logs (DL) over GF(p) More...

Go to the source code of this file.

## Classes

class | DL_GroupParameters_IntegerBased
| Integer-based GroupParameters specialization. More...
class | DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >
| Integer-based GroupParameters default implementation. More...
class | DL_GroupParameters_GFP
| GF(p) group parameters. More...
class | DL_GroupParameters_GFP_DefaultSafePrime
| GF(p) group parameters that default to safe primes. More...
class | DL_GroupParameters_ElGamal
| ElGamal encryption for safe interop. More...
class | DL_Algorithm_GDSA< T >
| GDSA algorithm. More...
class | DL_Algorithm_DSA_RFC6979< T, H >
| DSA signature algorithm based on RFC 6979. More...
class | DL_Algorithm_GDSA_ISO15946< T >
| German Digital Signature Algorithm. More...
class | DL_Algorithm_NR< T >
| NR algorithm. More...
class | DL_PublicKey_GFP< GP >
| Discrete Log (DL) public key in GF(p) groups. More...
class | DL_PrivateKey_GFP< GP >
| Discrete Log (DL) private key in GF(p) groups. More...
struct | DL_SignatureKeys_GFP
| Discrete Log (DL) signing/verification keys in GF(p) groups. More...
struct | DL_CryptoKeys_GFP
| Discrete Log (DL) encryption/decryption keys in GF(p) groups. More...
struct | DL_CryptoKeys_ElGamal
| ElGamal encryption keys for safe interop. More...
struct | GDSA< H >
| DSA signature scheme. More...
struct | NR< H >
| NR signature scheme. More...
class | DL_GroupParameters_DSA
| DSA group parameters. More...
struct | DL_Keys_DSA
| DSA keys. More...
class | DSA2< H >
| DSA signature scheme. More...
struct | DSA_RFC6979< H >
| DSA deterministic signature scheme. More...
class | DL_EncryptionAlgorithm_Xor< MAC, DHAES_MODE, LABEL_OCTETS >
| P1363 based XOR Encryption Method. More...
class | DL_KeyDerivationAlgorithm_P1363< T, DHAES_MODE, KDF >
| P1363 based Key Derivation Method. More...
struct | DLIES< HASH, COFACTOR_OPTION, DHAES_MODE, LABEL_OCTETS >
| Discrete Log Integrated Encryption Scheme. More...

## Typedefs

typedef DSA2< SHA1 > | DSA
| DSA with SHA-1, typedef'd for backwards compatibility.

## Variables

| DL_GroupParameters< Integer >
| DL_GroupParameters_IntegerBasedImpl< ModExpPrecomputation >
| DL_Algorithm_GDSA< Integer >
| DL_Algorithm_DSA_RFC6979< Integer, SHA1 >
| DL_Algorithm_DSA_RFC6979< Integer, SHA224 >
| DL_Algorithm_DSA_RFC6979< Integer, SHA256 >
| DL_Algorithm_DSA_RFC6979< Integer, SHA384 >
| DL_Algorithm_DSA_RFC6979< Integer, SHA512 >
| DL_PublicKey_GFP< DL_GroupParameters_DSA >
| DL_PrivateKey_GFP< DL_GroupParameters_DSA >
| DL_PrivateKey_WithSignaturePairwiseConsistencyTest< DL_PrivateKey_GFP< DL_GroupParameters_DSA >, DSA2< SHA1 > >

## Detailed Description

Classes and functions for schemes based on Discrete Logs (DL) over GF(p)

Definition in file gfpcrypt.h.

## Typedef Documentation

## DSA

typedef DSA2<SHA1> DSA

DSA with SHA-1, typedef'd for backwards compatibility.

Definition at line 851 of file gfpcrypt.h.

## Variable Documentation

## DL_GroupParameters< Integer >

DL_GroupParameters< Integer >

Definition at line 1 of file gfpcrypt.h.

## DL_GroupParameters_IntegerBasedImpl< ModExpPrecomputation >

DL_GroupParameters_IntegerBasedImpl< ModExpPrecomputation >

Definition at line 34 of file gfpcrypt.h.

## DL_Algorithm_GDSA< Integer >

DL_Algorithm_GDSA< Integer >

Definition at line 291 of file gfpcrypt.h.

## DL_Algorithm_DSA_RFC6979< Integer, SHA1 >

DL_Algorithm_DSA_RFC6979< Integer, SHA1 >

Definition at line 291 of file gfpcrypt.h.

## DL_Algorithm_DSA_RFC6979< Integer, SHA224 >

DL_Algorithm_DSA_RFC6979< Integer, SHA224 >

Definition at line 291 of file gfpcrypt.h.

## DL_Algorithm_DSA_RFC6979< Integer, SHA256 >

DL_Algorithm_DSA_RFC6979< Integer, SHA256 >

Definition at line 291 of file gfpcrypt.h.

## DL_Algorithm_DSA_RFC6979< Integer, SHA384 >

DL_Algorithm_DSA_RFC6979< Integer, SHA384 >

Definition at line 291 of file gfpcrypt.h.

## DL_Algorithm_DSA_RFC6979< Integer, SHA512 >

DL_Algorithm_DSA_RFC6979< Integer, SHA512 >

Definition at line 291 of file gfpcrypt.h.

## DL_PublicKey_GFP< DL_GroupParameters_DSA >

DL_PublicKey_GFP< DL_GroupParameters_DSA >

Definition at line 851 of file gfpcrypt.h.

## DL_PrivateKey_GFP< DL_GroupParameters_DSA >

DL_PrivateKey_GFP< DL_GroupParameters_DSA >

Definition at line 851 of file gfpcrypt.h.

## DL_PrivateKey_WithSignaturePairwiseConsistencyTest< DL_PrivateKey_GFP< DL_GroupParameters_DSA >, DSA2< SHA1 > >

DL_PrivateKey_WithSignaturePairwiseConsistencyTest< DL_PrivateKey_GFP< DL_GroupParameters_DSA >, DSA2< SHA1 > >

Definition at line 851 of file gfpcrypt.h.